# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt

class AdminStatsBenny(BaseModel):
    """
    AdminStatsBenny
    """
    active_admins: Optional[StrictInt] = Field(None, alias="activeAdmins")
    active_editors: Optional[StrictInt] = Field(None, alias="activeEditors")
    active_sessions: Optional[StrictInt] = Field(None, alias="activeSessions")
    active_users: Optional[StrictInt] = Field(None, alias="activeUsers")
    active_viewers: Optional[StrictInt] = Field(None, alias="activeViewers")
    admins: Optional[StrictInt] = None
    alerts: Optional[StrictInt] = None
    daily_active_admins: Optional[StrictInt] = Field(None, alias="dailyActiveAdmins")
    daily_active_editors: Optional[StrictInt] = Field(None, alias="dailyActiveEditors")
    daily_active_sessions: Optional[StrictInt] = Field(None, alias="dailyActiveSessions")
    daily_active_users: Optional[StrictInt] = Field(None, alias="dailyActiveUsers")
    daily_active_viewers: Optional[StrictInt] = Field(None, alias="dailyActiveViewers")
    dashboards: Optional[StrictInt] = None
    datasources: Optional[StrictInt] = None
    editors: Optional[StrictInt] = None
    monthly_active_users: Optional[StrictInt] = Field(None, alias="monthlyActiveUsers")
    orgs: Optional[StrictInt] = None
    playlists: Optional[StrictInt] = None
    snapshots: Optional[StrictInt] = None
    stars: Optional[StrictInt] = None
    tags: Optional[StrictInt] = None
    users: Optional[StrictInt] = None
    viewers: Optional[StrictInt] = None
    __properties = ["activeAdmins", "activeEditors", "activeSessions", "activeUsers", "activeViewers", "admins", "alerts", "dailyActiveAdmins", "dailyActiveEditors", "dailyActiveSessions", "dailyActiveUsers", "dailyActiveViewers", "dashboards", "datasources", "editors", "monthlyActiveUsers", "orgs", "playlists", "snapshots", "stars", "tags", "users", "viewers"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AdminStatsBenny:
        """Create an instance of AdminStatsBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AdminStatsBenny:
        """Create an instance of AdminStatsBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AdminStatsBenny.parse_obj(obj)

        _obj = AdminStatsBenny.parse_obj({
            "active_admins": obj.get("activeAdmins"),
            "active_editors": obj.get("activeEditors"),
            "active_sessions": obj.get("activeSessions"),
            "active_users": obj.get("activeUsers"),
            "active_viewers": obj.get("activeViewers"),
            "admins": obj.get("admins"),
            "alerts": obj.get("alerts"),
            "daily_active_admins": obj.get("dailyActiveAdmins"),
            "daily_active_editors": obj.get("dailyActiveEditors"),
            "daily_active_sessions": obj.get("dailyActiveSessions"),
            "daily_active_users": obj.get("dailyActiveUsers"),
            "daily_active_viewers": obj.get("dailyActiveViewers"),
            "dashboards": obj.get("dashboards"),
            "datasources": obj.get("datasources"),
            "editors": obj.get("editors"),
            "monthly_active_users": obj.get("monthlyActiveUsers"),
            "orgs": obj.get("orgs"),
            "playlists": obj.get("playlists"),
            "snapshots": obj.get("snapshots"),
            "stars": obj.get("stars"),
            "tags": obj.get("tags"),
            "users": obj.get("users"),
            "viewers": obj.get("viewers")
        })
        return _obj


