# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class AlertNotificationBenny(BaseModel):
    """
    AlertNotificationBenny
    """
    created: Optional[datetime] = None
    disable_resolve_message: Optional[StrictBool] = Field(None, alias="disableResolveMessage")
    frequency: Optional[StrictStr] = None
    id: Optional[StrictInt] = None
    is_default: Optional[StrictBool] = Field(None, alias="isDefault")
    name: Optional[StrictStr] = None
    secure_fields: Optional[Dict[str, StrictBool]] = Field(None, alias="secureFields")
    send_reminder: Optional[StrictBool] = Field(None, alias="sendReminder")
    settings: Optional[Dict[str, Any]] = None
    type: Optional[StrictStr] = None
    uid: Optional[StrictStr] = None
    updated: Optional[datetime] = None
    __properties = ["created", "disableResolveMessage", "frequency", "id", "isDefault", "name", "secureFields", "sendReminder", "settings", "type", "uid", "updated"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AlertNotificationBenny:
        """Create an instance of AlertNotificationBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AlertNotificationBenny:
        """Create an instance of AlertNotificationBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AlertNotificationBenny.parse_obj(obj)

        _obj = AlertNotificationBenny.parse_obj({
            "created": obj.get("created"),
            "disable_resolve_message": obj.get("disableResolveMessage"),
            "frequency": obj.get("frequency"),
            "id": obj.get("id"),
            "is_default": obj.get("isDefault"),
            "name": obj.get("name"),
            "secure_fields": obj.get("secureFields"),
            "send_reminder": obj.get("sendReminder"),
            "settings": obj.get("settings"),
            "type": obj.get("type"),
            "uid": obj.get("uid"),
            "updated": obj.get("updated")
        })
        return _obj


