# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class CreateDashboardSnapshotCommandBenny(BaseModel):
    """
    CreateDashboardSnapshotCommandBenny
    """
    dashboard: Dict[str, Any] = Field(...)
    delete_key: Optional[StrictStr] = Field(None, alias="deleteKey", description="Unique key used to delete the snapshot. It is different from the `key` so that only the creator can delete the snapshot. Required if `external` is `true`.")
    expires: Optional[StrictInt] = Field(0, description="When the snapshot should expire in seconds in seconds. Default is never to expire.")
    external: Optional[StrictBool] = Field(False, description="these are passed when storing an external snapshot ref Save the snapshot on an external server rather than locally.")
    key: Optional[StrictStr] = Field(None, description="Define the unique key. Required if `external` is `true`.")
    name: Optional[StrictStr] = Field(None, description="Snapshot name")
    __properties = ["dashboard", "deleteKey", "expires", "external", "key", "name"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateDashboardSnapshotCommandBenny:
        """Create an instance of CreateDashboardSnapshotCommandBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateDashboardSnapshotCommandBenny:
        """Create an instance of CreateDashboardSnapshotCommandBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateDashboardSnapshotCommandBenny.parse_obj(obj)

        _obj = CreateDashboardSnapshotCommandBenny.parse_obj({
            "dashboard": obj.get("dashboard"),
            "delete_key": obj.get("deleteKey"),
            "expires": obj.get("expires") if obj.get("expires") is not None else 0,
            "external": obj.get("external") if obj.get("external") is not None else False,
            "key": obj.get("key"),
            "name": obj.get("name")
        })
        return _obj


