# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, validator

class CreateLibraryElementCommandBenny(BaseModel):
    """
    CreateLibraryElementCommand is the command for adding a LibraryElement  # noqa: E501
    """
    folder_id: Optional[StrictInt] = Field(None, alias="folderId", description="ID of the folder where the library element is stored.")
    folder_uid: Optional[StrictStr] = Field(None, alias="folderUid", description="UID of the folder where the library element is stored.")
    kind: Optional[StrictInt] = Field(None, description="Kind of element to create, Use 1 for library panels or 2 for c. Description: 1 - library panels 2 - library variables")
    model: Optional[Dict[str, Any]] = Field(None, description="The JSON model for the library element.")
    name: Optional[StrictStr] = Field(None, description="Name of the library element.")
    uid: Optional[StrictStr] = None
    __properties = ["folderId", "folderUid", "kind", "model", "name", "uid"]

    @validator('kind')
    def kind_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in (1, 2):
            raise ValueError("must be one of enum values (1, 2)")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateLibraryElementCommandBenny:
        """Create an instance of CreateLibraryElementCommandBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateLibraryElementCommandBenny:
        """Create an instance of CreateLibraryElementCommandBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateLibraryElementCommandBenny.parse_obj(obj)

        _obj = CreateLibraryElementCommandBenny.parse_obj({
            "folder_id": obj.get("folderId"),
            "folder_uid": obj.get("folderUid"),
            "kind": obj.get("kind"),
            "model": obj.get("model"),
            "name": obj.get("name"),
            "uid": obj.get("uid")
        })
        return _obj


