# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, validator

class DashboardACLInfoDTOBenny(BaseModel):
    """
    DashboardACLInfoDTOBenny
    """
    created: Optional[datetime] = None
    dashboard_id: Optional[StrictInt] = Field(None, alias="dashboardId")
    folder_id: Optional[StrictInt] = Field(None, alias="folderId")
    inherited: Optional[StrictBool] = None
    is_folder: Optional[StrictBool] = Field(None, alias="isFolder")
    permission: Optional[StrictInt] = None
    permission_name: Optional[StrictStr] = Field(None, alias="permissionName")
    role: Optional[StrictStr] = None
    slug: Optional[StrictStr] = None
    team: Optional[StrictStr] = None
    team_avatar_url: Optional[StrictStr] = Field(None, alias="teamAvatarUrl")
    team_email: Optional[StrictStr] = Field(None, alias="teamEmail")
    team_id: Optional[StrictInt] = Field(None, alias="teamId")
    title: Optional[StrictStr] = None
    uid: Optional[StrictStr] = None
    updated: Optional[datetime] = None
    url: Optional[StrictStr] = None
    user_avatar_url: Optional[StrictStr] = Field(None, alias="userAvatarUrl")
    user_email: Optional[StrictStr] = Field(None, alias="userEmail")
    user_id: Optional[StrictInt] = Field(None, alias="userId")
    user_login: Optional[StrictStr] = Field(None, alias="userLogin")
    __properties = ["created", "dashboardId", "folderId", "inherited", "isFolder", "permission", "permissionName", "role", "slug", "team", "teamAvatarUrl", "teamEmail", "teamId", "title", "uid", "updated", "url", "userAvatarUrl", "userEmail", "userId", "userLogin"]

    @validator('role')
    def role_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Viewer', 'Editor', 'Admin'):
            raise ValueError("must be one of enum values ('Viewer', 'Editor', 'Admin')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DashboardACLInfoDTOBenny:
        """Create an instance of DashboardACLInfoDTOBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DashboardACLInfoDTOBenny:
        """Create an instance of DashboardACLInfoDTOBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DashboardACLInfoDTOBenny.parse_obj(obj)

        _obj = DashboardACLInfoDTOBenny.parse_obj({
            "created": obj.get("created"),
            "dashboard_id": obj.get("dashboardId"),
            "folder_id": obj.get("folderId"),
            "inherited": obj.get("inherited"),
            "is_folder": obj.get("isFolder"),
            "permission": obj.get("permission"),
            "permission_name": obj.get("permissionName"),
            "role": obj.get("role"),
            "slug": obj.get("slug"),
            "team": obj.get("team"),
            "team_avatar_url": obj.get("teamAvatarUrl"),
            "team_email": obj.get("teamEmail"),
            "team_id": obj.get("teamId"),
            "title": obj.get("title"),
            "uid": obj.get("uid"),
            "updated": obj.get("updated"),
            "url": obj.get("url"),
            "user_avatar_url": obj.get("userAvatarUrl"),
            "user_email": obj.get("userEmail"),
            "user_id": obj.get("userId"),
            "user_login": obj.get("userLogin")
        })
        return _obj


