# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class DashboardMetaBenny(BaseModel):
    """
    DashboardMetaBenny
    """
    annotations_permissions: Optional[AnnotationPermissionBennyBenny] = Field(None, alias="annotationsPermissions")
    can_admin: Optional[StrictBool] = Field(None, alias="canAdmin")
    can_delete: Optional[StrictBool] = Field(None, alias="canDelete")
    can_edit: Optional[StrictBool] = Field(None, alias="canEdit")
    can_save: Optional[StrictBool] = Field(None, alias="canSave")
    can_star: Optional[StrictBool] = Field(None, alias="canStar")
    created: Optional[datetime] = None
    created_by: Optional[StrictStr] = Field(None, alias="createdBy")
    expires: Optional[datetime] = None
    folder_id: Optional[StrictInt] = Field(None, alias="folderId")
    folder_title: Optional[StrictStr] = Field(None, alias="folderTitle")
    folder_uid: Optional[StrictStr] = Field(None, alias="folderUid")
    folder_url: Optional[StrictStr] = Field(None, alias="folderUrl")
    has_acl: Optional[StrictBool] = Field(None, alias="hasAcl")
    is_folder: Optional[StrictBool] = Field(None, alias="isFolder")
    is_snapshot: Optional[StrictBool] = Field(None, alias="isSnapshot")
    is_starred: Optional[StrictBool] = Field(None, alias="isStarred")
    provisioned: Optional[StrictBool] = None
    provisioned_external_id: Optional[StrictStr] = Field(None, alias="provisionedExternalId")
    public_dashboard_access_token: Optional[StrictStr] = Field(None, alias="publicDashboardAccessToken")
    public_dashboard_enabled: Optional[StrictBool] = Field(None, alias="publicDashboardEnabled")
    public_dashboard_uid: Optional[StrictStr] = Field(None, alias="publicDashboardUid")
    slug: Optional[StrictStr] = None
    type: Optional[StrictStr] = None
    updated: Optional[datetime] = None
    updated_by: Optional[StrictStr] = Field(None, alias="updatedBy")
    url: Optional[StrictStr] = None
    version: Optional[StrictInt] = None
    __properties = ["annotationsPermissions", "canAdmin", "canDelete", "canEdit", "canSave", "canStar", "created", "createdBy", "expires", "folderId", "folderTitle", "folderUid", "folderUrl", "hasAcl", "isFolder", "isSnapshot", "isStarred", "provisioned", "provisionedExternalId", "publicDashboardAccessToken", "publicDashboardEnabled", "publicDashboardUid", "slug", "type", "updated", "updatedBy", "url", "version"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DashboardMetaBenny:
        """Create an instance of DashboardMetaBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of annotations_permissions
        if self.annotations_permissions:
            _dict['annotationsPermissions'] = self.annotations_permissions.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DashboardMetaBenny:
        """Create an instance of DashboardMetaBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DashboardMetaBenny.parse_obj(obj)

        _obj = DashboardMetaBenny.parse_obj({
            "annotations_permissions": AnnotationPermissionBennyBenny.from_dict(obj.get("annotationsPermissions")) if obj.get("annotationsPermissions") is not None else None,
            "can_admin": obj.get("canAdmin"),
            "can_delete": obj.get("canDelete"),
            "can_edit": obj.get("canEdit"),
            "can_save": obj.get("canSave"),
            "can_star": obj.get("canStar"),
            "created": obj.get("created"),
            "created_by": obj.get("createdBy"),
            "expires": obj.get("expires"),
            "folder_id": obj.get("folderId"),
            "folder_title": obj.get("folderTitle"),
            "folder_uid": obj.get("folderUid"),
            "folder_url": obj.get("folderUrl"),
            "has_acl": obj.get("hasAcl"),
            "is_folder": obj.get("isFolder"),
            "is_snapshot": obj.get("isSnapshot"),
            "is_starred": obj.get("isStarred"),
            "provisioned": obj.get("provisioned"),
            "provisioned_external_id": obj.get("provisionedExternalId"),
            "public_dashboard_access_token": obj.get("publicDashboardAccessToken"),
            "public_dashboard_enabled": obj.get("publicDashboardEnabled"),
            "public_dashboard_uid": obj.get("publicDashboardUid"),
            "slug": obj.get("slug"),
            "type": obj.get("type"),
            "updated": obj.get("updated"),
            "updated_by": obj.get("updatedBy"),
            "url": obj.get("url"),
            "version": obj.get("version")
        })
        return _obj


