# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class DashboardSnapshotDTOBenny(BaseModel):
    """
    DashboardSnapshotDTO without dashboard map  # noqa: E501
    """
    created: Optional[datetime] = None
    expires: Optional[datetime] = None
    external: Optional[StrictBool] = None
    external_url: Optional[StrictStr] = Field(None, alias="externalUrl")
    id: Optional[StrictInt] = None
    key: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    org_id: Optional[StrictInt] = Field(None, alias="orgId")
    updated: Optional[datetime] = None
    user_id: Optional[StrictInt] = Field(None, alias="userId")
    __properties = ["created", "expires", "external", "externalUrl", "id", "key", "name", "orgId", "updated", "userId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DashboardSnapshotDTOBenny:
        """Create an instance of DashboardSnapshotDTOBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DashboardSnapshotDTOBenny:
        """Create an instance of DashboardSnapshotDTOBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DashboardSnapshotDTOBenny.parse_obj(obj)

        _obj = DashboardSnapshotDTOBenny.parse_obj({
            "created": obj.get("created"),
            "expires": obj.get("expires"),
            "external": obj.get("external"),
            "external_url": obj.get("externalUrl"),
            "id": obj.get("id"),
            "key": obj.get("key"),
            "name": obj.get("name"),
            "org_id": obj.get("orgId"),
            "updated": obj.get("updated"),
            "user_id": obj.get("userId")
        })
        return _obj


