# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class DashboardVersionMetaBenny(BaseModel):
    """
    DashboardVersionMeta extends the DashboardVersionDTO with the names associated with the UserIds, overriding the field with the same name from the DashboardVersionDTO model.  # noqa: E501
    """
    created: Optional[datetime] = None
    created_by: Optional[StrictStr] = Field(None, alias="createdBy")
    dashboard_id: Optional[StrictInt] = Field(None, alias="dashboardId")
    data: Optional[Dict[str, Any]] = None
    id: Optional[StrictInt] = None
    message: Optional[StrictStr] = None
    parent_version: Optional[StrictInt] = Field(None, alias="parentVersion")
    restored_from: Optional[StrictInt] = Field(None, alias="restoredFrom")
    uid: Optional[StrictStr] = None
    version: Optional[StrictInt] = None
    __properties = ["created", "createdBy", "dashboardId", "data", "id", "message", "parentVersion", "restoredFrom", "uid", "version"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DashboardVersionMetaBenny:
        """Create an instance of DashboardVersionMetaBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DashboardVersionMetaBenny:
        """Create an instance of DashboardVersionMetaBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DashboardVersionMetaBenny.parse_obj(obj)

        _obj = DashboardVersionMetaBenny.parse_obj({
            "created": obj.get("created"),
            "created_by": obj.get("createdBy"),
            "dashboard_id": obj.get("dashboardId"),
            "data": obj.get("data"),
            "id": obj.get("id"),
            "message": obj.get("message"),
            "parent_version": obj.get("parentVersion"),
            "restored_from": obj.get("restoredFrom"),
            "uid": obj.get("uid"),
            "version": obj.get("version")
        })
        return _obj


