# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class DataSourceBenny(BaseModel):
    """
    DataSourceBenny
    """
    access: Optional[StrictStr] = None
    access_control: Optional[Dict[str, StrictBool]] = Field(None, alias="accessControl", description="Metadata contains user accesses for a given resource Ex: map[string]bool{\"create\":true, \"delete\": true}")
    basic_auth: Optional[StrictBool] = Field(None, alias="basicAuth")
    basic_auth_user: Optional[StrictStr] = Field(None, alias="basicAuthUser")
    database: Optional[StrictStr] = None
    id: Optional[StrictInt] = None
    is_default: Optional[StrictBool] = Field(None, alias="isDefault")
    json_data: Optional[Dict[str, Any]] = Field(None, alias="jsonData")
    name: Optional[StrictStr] = None
    org_id: Optional[StrictInt] = Field(None, alias="orgId")
    read_only: Optional[StrictBool] = Field(None, alias="readOnly")
    secure_json_fields: Optional[Dict[str, StrictBool]] = Field(None, alias="secureJsonFields")
    type: Optional[StrictStr] = None
    type_logo_url: Optional[StrictStr] = Field(None, alias="typeLogoUrl")
    uid: Optional[StrictStr] = None
    url: Optional[StrictStr] = None
    user: Optional[StrictStr] = None
    version: Optional[StrictInt] = None
    with_credentials: Optional[StrictBool] = Field(None, alias="withCredentials")
    __properties = ["access", "accessControl", "basicAuth", "basicAuthUser", "database", "id", "isDefault", "jsonData", "name", "orgId", "readOnly", "secureJsonFields", "type", "typeLogoUrl", "uid", "url", "user", "version", "withCredentials"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DataSourceBenny:
        """Create an instance of DataSourceBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DataSourceBenny:
        """Create an instance of DataSourceBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DataSourceBenny.parse_obj(obj)

        _obj = DataSourceBenny.parse_obj({
            "access": obj.get("access"),
            "access_control": obj.get("accessControl"),
            "basic_auth": obj.get("basicAuth"),
            "basic_auth_user": obj.get("basicAuthUser"),
            "database": obj.get("database"),
            "id": obj.get("id"),
            "is_default": obj.get("isDefault"),
            "json_data": obj.get("jsonData"),
            "name": obj.get("name"),
            "org_id": obj.get("orgId"),
            "read_only": obj.get("readOnly"),
            "secure_json_fields": obj.get("secureJsonFields"),
            "type": obj.get("type"),
            "type_logo_url": obj.get("typeLogoUrl"),
            "uid": obj.get("uid"),
            "url": obj.get("url"),
            "user": obj.get("user"),
            "version": obj.get("version"),
            "with_credentials": obj.get("withCredentials")
        })
        return _obj


