# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist

class EnumFieldConfigBenny(BaseModel):
    """
    Enum field config Vector values are used as lookup keys into the enum fields  # noqa: E501
    """
    color: Optional[conlist(StrictStr)] = Field(None, description="Color is the color value for a given index (empty is undefined)")
    description: Optional[conlist(StrictStr)] = Field(None, description="Description of the enum state")
    icon: Optional[conlist(StrictStr)] = Field(None, description="Icon supports setting an icon for a given index value")
    text: Optional[conlist(StrictStr)] = Field(None, description="Value is the string display value for a given index")
    __properties = ["color", "description", "icon", "text"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> EnumFieldConfigBenny:
        """Create an instance of EnumFieldConfigBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> EnumFieldConfigBenny:
        """Create an instance of EnumFieldConfigBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return EnumFieldConfigBenny.parse_obj(obj)

        _obj = EnumFieldConfigBenny.parse_obj({
            "color": obj.get("color"),
            "description": obj.get("description"),
            "icon": obj.get("icon"),
            "text": obj.get("text")
        })
        return _obj


