# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class ErrorResponseBodyBenny(BaseModel):
    """
    ErrorResponseBodyBenny
    """
    error: Optional[StrictStr] = Field(None, description="Error An optional detailed description of the actual error. Only included if running in developer mode.")
    message: StrictStr = Field(..., description="a human readable version of the error")
    status: Optional[StrictStr] = Field(None, description="Status An optional status to denote the cause of the error.  For example, a 412 Precondition Failed error may include additional information of why that error happened.")
    __properties = ["error", "message", "status"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ErrorResponseBodyBenny:
        """Create an instance of ErrorResponseBodyBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ErrorResponseBodyBenny:
        """Create an instance of ErrorResponseBodyBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ErrorResponseBodyBenny.parse_obj(obj)

        _obj = ErrorResponseBodyBenny.parse_obj({
            "error": obj.get("error"),
            "message": obj.get("message"),
            "status": obj.get("status")
        })
        return _obj


