# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class FolderBenny(BaseModel):
    """
    FolderBenny
    """
    access_control: Optional[Dict[str, StrictBool]] = Field(None, alias="accessControl", description="Metadata contains user accesses for a given resource Ex: map[string]bool{\"create\":true, \"delete\": true}")
    can_admin: Optional[StrictBool] = Field(None, alias="canAdmin")
    can_delete: Optional[StrictBool] = Field(None, alias="canDelete")
    can_edit: Optional[StrictBool] = Field(None, alias="canEdit")
    can_save: Optional[StrictBool] = Field(None, alias="canSave")
    created: Optional[datetime] = None
    created_by: Optional[StrictStr] = Field(None, alias="createdBy")
    has_acl: Optional[StrictBool] = Field(None, alias="hasAcl")
    id: Optional[StrictInt] = None
    parent_uid: Optional[StrictStr] = Field(None, alias="parentUid", description="only used if nested folders are enabled")
    title: Optional[StrictStr] = None
    uid: Optional[StrictStr] = None
    updated: Optional[datetime] = None
    updated_by: Optional[StrictStr] = Field(None, alias="updatedBy")
    url: Optional[StrictStr] = None
    version: Optional[StrictInt] = None
    __properties = ["accessControl", "canAdmin", "canDelete", "canEdit", "canSave", "created", "createdBy", "hasAcl", "id", "parentUid", "title", "uid", "updated", "updatedBy", "url", "version"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FolderBenny:
        """Create an instance of FolderBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FolderBenny:
        """Create an instance of FolderBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FolderBenny.parse_obj(obj)

        _obj = FolderBenny.parse_obj({
            "access_control": obj.get("accessControl"),
            "can_admin": obj.get("canAdmin"),
            "can_delete": obj.get("canDelete"),
            "can_edit": obj.get("canEdit"),
            "can_save": obj.get("canSave"),
            "created": obj.get("created"),
            "created_by": obj.get("createdBy"),
            "has_acl": obj.get("hasAcl"),
            "id": obj.get("id"),
            "parent_uid": obj.get("parentUid"),
            "title": obj.get("title"),
            "uid": obj.get("uid"),
            "updated": obj.get("updated"),
            "updated_by": obj.get("updatedBy"),
            "url": obj.get("url"),
            "version": obj.get("version")
        })
        return _obj


