# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictStr

class GettableExtendedRuleNodeBenny(BaseModel):
    """
    GettableExtendedRuleNodeBenny
    """
    alert: Optional[StrictStr] = None
    annotations: Optional[Dict[str, StrictStr]] = None
    expr: Optional[StrictStr] = None
    var_for: Optional[StrictStr] = Field(None, alias="for")
    grafana_alert: Optional[GettableGrafanaRuleBennyBenny] = None
    labels: Optional[Dict[str, StrictStr]] = None
    record: Optional[StrictStr] = None
    __properties = ["alert", "annotations", "expr", "for", "grafana_alert", "labels", "record"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GettableExtendedRuleNodeBenny:
        """Create an instance of GettableExtendedRuleNodeBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of grafana_alert
        if self.grafana_alert:
            _dict['grafana_alert'] = self.grafana_alert.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GettableExtendedRuleNodeBenny:
        """Create an instance of GettableExtendedRuleNodeBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GettableExtendedRuleNodeBenny.parse_obj(obj)

        _obj = GettableExtendedRuleNodeBenny.parse_obj({
            "alert": obj.get("alert"),
            "annotations": obj.get("annotations"),
            "expr": obj.get("expr"),
            "var_for": obj.get("for"),
            "grafana_alert": GettableGrafanaRuleBennyBenny.from_dict(obj.get("grafana_alert")) if obj.get("grafana_alert") is not None else None,
            "labels": obj.get("labels"),
            "record": obj.get("record")
        })
        return _obj


