# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist

class HitBenny(BaseModel):
    """
    HitBenny
    """
    folder_id: Optional[StrictInt] = Field(None, alias="folderId")
    folder_title: Optional[StrictStr] = Field(None, alias="folderTitle")
    folder_uid: Optional[StrictStr] = Field(None, alias="folderUid")
    folder_url: Optional[StrictStr] = Field(None, alias="folderUrl")
    id: Optional[StrictInt] = None
    is_starred: Optional[StrictBool] = Field(None, alias="isStarred")
    slug: Optional[StrictStr] = None
    sort_meta: Optional[StrictInt] = Field(None, alias="sortMeta")
    sort_meta_name: Optional[StrictStr] = Field(None, alias="sortMetaName")
    tags: Optional[conlist(StrictStr)] = None
    title: Optional[StrictStr] = None
    type: Optional[StrictStr] = None
    uid: Optional[StrictStr] = None
    uri: Optional[StrictStr] = None
    url: Optional[StrictStr] = None
    __properties = ["folderId", "folderTitle", "folderUid", "folderUrl", "id", "isStarred", "slug", "sortMeta", "sortMetaName", "tags", "title", "type", "uid", "uri", "url"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> HitBenny:
        """Create an instance of HitBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> HitBenny:
        """Create an instance of HitBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return HitBenny.parse_obj(obj)

        _obj = HitBenny.parse_obj({
            "folder_id": obj.get("folderId"),
            "folder_title": obj.get("folderTitle"),
            "folder_uid": obj.get("folderUid"),
            "folder_url": obj.get("folderUrl"),
            "id": obj.get("id"),
            "is_starred": obj.get("isStarred"),
            "slug": obj.get("slug"),
            "sort_meta": obj.get("sortMeta"),
            "sort_meta_name": obj.get("sortMetaName"),
            "tags": obj.get("tags"),
            "title": obj.get("title"),
            "type": obj.get("type"),
            "uid": obj.get("uid"),
            "uri": obj.get("uri"),
            "url": obj.get("url")
        })
        return _obj


