# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist

class ImportDashboardRequestBenny(BaseModel):
    """
    ImportDashboardRequestBenny
    """
    dashboard: Optional[Dict[str, Any]] = None
    folder_id: Optional[StrictInt] = Field(None, alias="folderId")
    folder_uid: Optional[StrictStr] = Field(None, alias="folderUid")
    inputs: Optional[conlist(ImportDashboardInputBennyBenny)] = None
    overwrite: Optional[StrictBool] = None
    path: Optional[StrictStr] = None
    plugin_id: Optional[StrictStr] = Field(None, alias="pluginId")
    __properties = ["dashboard", "folderId", "folderUid", "inputs", "overwrite", "path", "pluginId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ImportDashboardRequestBenny:
        """Create an instance of ImportDashboardRequestBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in inputs (list)
        _items = []
        if self.inputs:
            for _item in self.inputs:
                if _item:
                    _items.append(_item.to_dict())
            _dict['inputs'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ImportDashboardRequestBenny:
        """Create an instance of ImportDashboardRequestBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ImportDashboardRequestBenny.parse_obj(obj)

        _obj = ImportDashboardRequestBenny.parse_obj({
            "dashboard": obj.get("dashboard"),
            "folder_id": obj.get("folderId"),
            "folder_uid": obj.get("folderUid"),
            "inputs": [ImportDashboardInputBennyBenny.from_dict(_item) for _item in obj.get("inputs")] if obj.get("inputs") is not None else None,
            "overwrite": obj.get("overwrite"),
            "path": obj.get("path"),
            "plugin_id": obj.get("pluginId")
        })
        return _obj


