# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class IntegrationBenny(BaseModel):
    """
    IntegrationBenny
    """
    last_notify_attempt: Optional[datetime] = Field(None, alias="lastNotifyAttempt", description="A timestamp indicating the last attempt to deliver a notification regardless of the outcome. Format: date-time")
    last_notify_attempt_duration: Optional[StrictStr] = Field(None, alias="lastNotifyAttemptDuration", description="Duration of the last attempt to deliver a notification in humanized format (`1s` or `15ms`, etc).")
    last_notify_attempt_error: Optional[StrictStr] = Field(None, alias="lastNotifyAttemptError", description="Error string for the last attempt to deliver a notification. Empty if the last attempt was successful.")
    name: StrictStr = Field(..., description="name")
    send_resolved: StrictBool = Field(..., alias="sendResolved", description="send resolved")
    __properties = ["lastNotifyAttempt", "lastNotifyAttemptDuration", "lastNotifyAttemptError", "name", "sendResolved"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IntegrationBenny:
        """Create an instance of IntegrationBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IntegrationBenny:
        """Create an instance of IntegrationBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IntegrationBenny.parse_obj(obj)

        _obj = IntegrationBenny.parse_obj({
            "last_notify_attempt": obj.get("lastNotifyAttempt"),
            "last_notify_attempt_duration": obj.get("lastNotifyAttemptDuration"),
            "last_notify_attempt_error": obj.get("lastNotifyAttemptError"),
            "name": obj.get("name"),
            "send_resolved": obj.get("sendResolved")
        })
        return _obj


