# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class LibraryElementConnectionDTOBenny(BaseModel):
    """
    LibraryElementConnectionDTOBenny
    """
    connection_id: Optional[StrictInt] = Field(None, alias="connectionId")
    connection_uid: Optional[StrictStr] = Field(None, alias="connectionUid")
    created: Optional[datetime] = None
    created_by: Optional[LibraryElementDTOMetaUserBennyBenny] = Field(None, alias="createdBy")
    element_id: Optional[StrictInt] = Field(None, alias="elementId")
    id: Optional[StrictInt] = None
    kind: Optional[StrictInt] = None
    __properties = ["connectionId", "connectionUid", "created", "createdBy", "elementId", "id", "kind"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LibraryElementConnectionDTOBenny:
        """Create an instance of LibraryElementConnectionDTOBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of created_by
        if self.created_by:
            _dict['createdBy'] = self.created_by.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LibraryElementConnectionDTOBenny:
        """Create an instance of LibraryElementConnectionDTOBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LibraryElementConnectionDTOBenny.parse_obj(obj)

        _obj = LibraryElementConnectionDTOBenny.parse_obj({
            "connection_id": obj.get("connectionId"),
            "connection_uid": obj.get("connectionUid"),
            "created": obj.get("created"),
            "created_by": LibraryElementDTOMetaUserBennyBenny.from_dict(obj.get("createdBy")) if obj.get("createdBy") is not None else None,
            "element_id": obj.get("elementId"),
            "id": obj.get("id"),
            "kind": obj.get("kind")
        })
        return _obj


