# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class LibraryElementDTOBenny(BaseModel):
    """
    LibraryElementDTOBenny
    """
    description: Optional[StrictStr] = None
    folder_id: Optional[StrictInt] = Field(None, alias="folderId")
    folder_uid: Optional[StrictStr] = Field(None, alias="folderUid")
    id: Optional[StrictInt] = None
    kind: Optional[StrictInt] = None
    meta: Optional[LibraryElementDTOMetaBennyBenny] = None
    model: Optional[Dict[str, Any]] = None
    name: Optional[StrictStr] = None
    org_id: Optional[StrictInt] = Field(None, alias="orgId")
    schema_version: Optional[StrictInt] = Field(None, alias="schemaVersion")
    type: Optional[StrictStr] = None
    uid: Optional[StrictStr] = None
    version: Optional[StrictInt] = None
    __properties = ["description", "folderId", "folderUid", "id", "kind", "meta", "model", "name", "orgId", "schemaVersion", "type", "uid", "version"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LibraryElementDTOBenny:
        """Create an instance of LibraryElementDTOBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of meta
        if self.meta:
            _dict['meta'] = self.meta.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LibraryElementDTOBenny:
        """Create an instance of LibraryElementDTOBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LibraryElementDTOBenny.parse_obj(obj)

        _obj = LibraryElementDTOBenny.parse_obj({
            "description": obj.get("description"),
            "folder_id": obj.get("folderId"),
            "folder_uid": obj.get("folderUid"),
            "id": obj.get("id"),
            "kind": obj.get("kind"),
            "meta": LibraryElementDTOMetaBennyBenny.from_dict(obj.get("meta")) if obj.get("meta") is not None else None,
            "model": obj.get("model"),
            "name": obj.get("name"),
            "org_id": obj.get("orgId"),
            "schema_version": obj.get("schemaVersion"),
            "type": obj.get("type"),
            "uid": obj.get("uid"),
            "version": obj.get("version")
        })
        return _obj


