# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class PlaylistBenny(BaseModel):
    """
    Playlist model  # noqa: E501
    """
    id: Optional[StrictInt] = None
    interval: Optional[StrictStr] = Field(None, description="Interval sets the time between switching views in a playlist. FIXME: Is this based on a standardized format or what options are available? Can datemath be used?")
    name: Optional[StrictStr] = Field(None, description="Name of the playlist.")
    uid: Optional[StrictStr] = Field(None, description="Unique playlist identifier. Generated on creation, either by the creator of the playlist of by the application.")
    __properties = ["id", "interval", "name", "uid"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PlaylistBenny:
        """Create an instance of PlaylistBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PlaylistBenny:
        """Create an instance of PlaylistBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PlaylistBenny.parse_obj(obj)

        _obj = PlaylistBenny.parse_obj({
            "id": obj.get("id"),
            "interval": obj.get("interval"),
            "name": obj.get("name"),
            "uid": obj.get("uid")
        })
        return _obj


