# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class PostableGrafanaReceiverBenny(BaseModel):
    """
    PostableGrafanaReceiverBenny
    """
    disable_resolve_message: Optional[StrictBool] = Field(None, alias="disableResolveMessage")
    name: Optional[StrictStr] = None
    secure_settings: Optional[Dict[str, StrictStr]] = Field(None, alias="secureSettings")
    settings: Optional[Dict[str, Any]] = None
    type: Optional[StrictStr] = None
    uid: Optional[StrictStr] = None
    __properties = ["disableResolveMessage", "name", "secureSettings", "settings", "type", "uid"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PostableGrafanaReceiverBenny:
        """Create an instance of PostableGrafanaReceiverBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PostableGrafanaReceiverBenny:
        """Create an instance of PostableGrafanaReceiverBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PostableGrafanaReceiverBenny.parse_obj(obj)

        _obj = PostableGrafanaReceiverBenny.parse_obj({
            "disable_resolve_message": obj.get("disableResolveMessage"),
            "name": obj.get("name"),
            "secure_settings": obj.get("secureSettings"),
            "settings": obj.get("settings"),
            "type": obj.get("type"),
            "uid": obj.get("uid")
        })
        return _obj


