# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class PreferencesBenny(BaseModel):
    """
    PreferencesBenny
    """
    home_dashboard_uid: Optional[StrictStr] = Field(None, alias="homeDashboardUID", description="UID for the home dashboard")
    language: Optional[StrictStr] = Field(None, description="Selected language (beta)")
    query_history: Optional[QueryHistoryPreferenceBennyBenny] = Field(None, alias="queryHistory")
    theme: Optional[StrictStr] = Field(None, description="Theme light, dark, empty is default")
    timezone: Optional[StrictStr] = Field(None, description="The timezone selection TODO: this should use the timezone defined in common")
    week_start: Optional[StrictStr] = Field(None, alias="weekStart", description="WeekStart day of the week (sunday, monday, etc)")
    __properties = ["homeDashboardUID", "language", "queryHistory", "theme", "timezone", "weekStart"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PreferencesBenny:
        """Create an instance of PreferencesBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of query_history
        if self.query_history:
            _dict['queryHistory'] = self.query_history.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PreferencesBenny:
        """Create an instance of PreferencesBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PreferencesBenny.parse_obj(obj)

        _obj = PreferencesBenny.parse_obj({
            "home_dashboard_uid": obj.get("homeDashboardUID"),
            "language": obj.get("language"),
            "query_history": QueryHistoryPreferenceBennyBenny.from_dict(obj.get("queryHistory")) if obj.get("queryHistory") is not None else None,
            "theme": obj.get("theme"),
            "timezone": obj.get("timezone"),
            "week_start": obj.get("weekStart")
        })
        return _obj


