# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist, constr, validator

class ProvisionedAlertRuleBenny(BaseModel):
    """
    ProvisionedAlertRuleBenny
    """
    annotations: Optional[Dict[str, StrictStr]] = None
    condition: StrictStr = Field(...)
    data: conlist(AlertQueryBennyBenny) = Field(...)
    exec_err_state: StrictStr = Field(..., alias="execErrState")
    folder_uid: StrictStr = Field(..., alias="folderUID")
    var_for: StrictInt = Field(..., alias="for")
    id: Optional[StrictInt] = None
    is_paused: Optional[StrictBool] = Field(None, alias="isPaused")
    labels: Optional[Dict[str, StrictStr]] = None
    no_data_state: StrictStr = Field(..., alias="noDataState")
    org_id: StrictInt = Field(..., alias="orgID")
    provenance: Optional[StrictStr] = None
    rule_group: constr(strict=True, max_length=190, min_length=1) = Field(..., alias="ruleGroup")
    title: constr(strict=True, max_length=190, min_length=1) = Field(...)
    uid: Optional[StrictStr] = None
    updated: Optional[datetime] = None
    __properties = ["annotations", "condition", "data", "execErrState", "folderUID", "for", "id", "isPaused", "labels", "noDataState", "orgID", "provenance", "ruleGroup", "title", "uid", "updated"]

    @validator('exec_err_state')
    def exec_err_state_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('Alerting', 'Error', 'OK'):
            raise ValueError("must be one of enum values ('Alerting', 'Error', 'OK')")
        return value

    @validator('no_data_state')
    def no_data_state_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('Alerting', 'NoData', 'OK'):
            raise ValueError("must be one of enum values ('Alerting', 'NoData', 'OK')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProvisionedAlertRuleBenny:
        """Create an instance of ProvisionedAlertRuleBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "updated",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in data (list)
        _items = []
        if self.data:
            for _item in self.data:
                if _item:
                    _items.append(_item.to_dict())
            _dict['data'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProvisionedAlertRuleBenny:
        """Create an instance of ProvisionedAlertRuleBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ProvisionedAlertRuleBenny.parse_obj(obj)

        _obj = ProvisionedAlertRuleBenny.parse_obj({
            "annotations": obj.get("annotations"),
            "condition": obj.get("condition"),
            "data": [AlertQueryBennyBenny.from_dict(_item) for _item in obj.get("data")] if obj.get("data") is not None else None,
            "exec_err_state": obj.get("execErrState"),
            "folder_uid": obj.get("folderUID"),
            "var_for": obj.get("for"),
            "id": obj.get("id"),
            "is_paused": obj.get("isPaused"),
            "labels": obj.get("labels"),
            "no_data_state": obj.get("noDataState"),
            "org_id": obj.get("orgID"),
            "provenance": obj.get("provenance"),
            "rule_group": obj.get("ruleGroup"),
            "title": obj.get("title"),
            "uid": obj.get("uid"),
            "updated": obj.get("updated")
        })
        return _obj


