# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, StrictBool, StrictStr

class PushoverConfigBenny(BaseModel):
    """
    PushoverConfigBenny
    """
    expire: Optional[StrictStr] = None
    html: Optional[StrictBool] = None
    http_config: Optional[HTTPClientConfigBennyBenny] = None
    message: Optional[StrictStr] = None
    priority: Optional[StrictStr] = None
    retry: Optional[StrictStr] = None
    send_resolved: Optional[StrictBool] = None
    sound: Optional[StrictStr] = None
    title: Optional[StrictStr] = None
    token: Optional[StrictStr] = None
    token_file: Optional[StrictStr] = None
    url: Optional[StrictStr] = None
    url_title: Optional[StrictStr] = None
    user_key: Optional[StrictStr] = None
    user_key_file: Optional[StrictStr] = None
    __properties = ["expire", "html", "http_config", "message", "priority", "retry", "send_resolved", "sound", "title", "token", "token_file", "url", "url_title", "user_key", "user_key_file"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PushoverConfigBenny:
        """Create an instance of PushoverConfigBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of http_config
        if self.http_config:
            _dict['http_config'] = self.http_config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PushoverConfigBenny:
        """Create an instance of PushoverConfigBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PushoverConfigBenny.parse_obj(obj)

        _obj = PushoverConfigBenny.parse_obj({
            "expire": obj.get("expire"),
            "html": obj.get("html"),
            "http_config": HTTPClientConfigBennyBenny.from_dict(obj.get("http_config")) if obj.get("http_config") is not None else None,
            "message": obj.get("message"),
            "priority": obj.get("priority"),
            "retry": obj.get("retry"),
            "send_resolved": obj.get("send_resolved"),
            "sound": obj.get("sound"),
            "title": obj.get("title"),
            "token": obj.get("token"),
            "token_file": obj.get("token_file"),
            "url": obj.get("url"),
            "url_title": obj.get("url_title"),
            "user_key": obj.get("user_key"),
            "user_key_file": obj.get("user_key_file")
        })
        return _obj


