# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictInt, StrictStr, conlist

class RecordingRuleJSONBenny(BaseModel):
    """
    RecordingRuleJSON is the external representation of a recording rule  # noqa: E501
    """
    active: Optional[StrictBool] = None
    count: Optional[StrictBool] = None
    description: Optional[StrictStr] = None
    dest_data_source_uid: Optional[StrictStr] = None
    id: Optional[StrictStr] = None
    interval: Optional[StrictInt] = None
    name: Optional[StrictStr] = None
    prom_name: Optional[StrictStr] = None
    queries: Optional[conlist(Dict[str, Any])] = None
    range: Optional[StrictInt] = None
    target_ref_id: Optional[StrictStr] = None
    __properties = ["active", "count", "description", "dest_data_source_uid", "id", "interval", "name", "prom_name", "queries", "range", "target_ref_id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RecordingRuleJSONBenny:
        """Create an instance of RecordingRuleJSONBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RecordingRuleJSONBenny:
        """Create an instance of RecordingRuleJSONBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RecordingRuleJSONBenny.parse_obj(obj)

        _obj = RecordingRuleJSONBenny.parse_obj({
            "active": obj.get("active"),
            "count": obj.get("count"),
            "description": obj.get("description"),
            "dest_data_source_uid": obj.get("dest_data_source_uid"),
            "id": obj.get("id"),
            "interval": obj.get("interval"),
            "name": obj.get("name"),
            "prom_name": obj.get("prom_name"),
            "queries": obj.get("queries"),
            "range": obj.get("range"),
            "target_ref_id": obj.get("target_ref_id")
        })
        return _obj


