# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, conlist

class RuleGroupBenny(BaseModel):
    """
    RuleGroupBenny
    """
    evaluation_time: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="evaluationTime")
    file: StrictStr = Field(...)
    interval: Union[StrictFloat, StrictInt] = Field(...)
    last_evaluation: Optional[datetime] = Field(None, alias="lastEvaluation")
    name: StrictStr = Field(...)
    rules: conlist(AlertingRuleBennyBenny) = Field(..., description="In order to preserve rule ordering, while exposing type (alerting or recording) specific properties, both alerting and recording rules are exposed in the same array.")
    __properties = ["evaluationTime", "file", "interval", "lastEvaluation", "name", "rules"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RuleGroupBenny:
        """Create an instance of RuleGroupBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in rules (list)
        _items = []
        if self.rules:
            for _item in self.rules:
                if _item:
                    _items.append(_item.to_dict())
            _dict['rules'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RuleGroupBenny:
        """Create an instance of RuleGroupBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RuleGroupBenny.parse_obj(obj)

        _obj = RuleGroupBenny.parse_obj({
            "evaluation_time": obj.get("evaluationTime"),
            "file": obj.get("file"),
            "interval": obj.get("interval"),
            "last_evaluation": obj.get("lastEvaluation"),
            "name": obj.get("name"),
            "rules": [AlertingRuleBennyBenny.from_dict(_item) for _item in obj.get("rules")] if obj.get("rules") is not None else None
        })
        return _obj


