# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, conlist

class SampleBenny(BaseModel):
    """
    SampleBenny
    """
    metric: Optional[conlist(LabelBennyBenny)] = Field(None, alias="Metric", description="Labels is a sorted set of labels. Order has to be guaranteed upon instantiation.")
    t: Optional[StrictInt] = Field(None, alias="T")
    v: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="V")
    __properties = ["Metric", "T", "V"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SampleBenny:
        """Create an instance of SampleBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in metric (list)
        _items = []
        if self.metric:
            for _item in self.metric:
                if _item:
                    _items.append(_item.to_dict())
            _dict['Metric'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SampleBenny:
        """Create an instance of SampleBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SampleBenny.parse_obj(obj)

        _obj = SampleBenny.parse_obj({
            "metric": [LabelBennyBenny.from_dict(_item) for _item in obj.get("Metric")] if obj.get("Metric") is not None else None,
            "t": obj.get("T"),
            "v": obj.get("V")
        })
        return _obj


