# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist

class ServiceAccountProfileDTOBenny(BaseModel):
    """
    ServiceAccountProfileDTOBenny
    """
    access_control: Optional[Dict[str, StrictBool]] = Field(None, alias="accessControl")
    avatar_url: Optional[StrictStr] = Field(None, alias="avatarUrl")
    created_at: Optional[datetime] = Field(None, alias="createdAt")
    id: Optional[StrictInt] = None
    is_disabled: Optional[StrictBool] = Field(None, alias="isDisabled")
    login: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    org_id: Optional[StrictInt] = Field(None, alias="orgId")
    role: Optional[StrictStr] = None
    teams: Optional[conlist(StrictStr)] = None
    tokens: Optional[StrictInt] = None
    updated_at: Optional[datetime] = Field(None, alias="updatedAt")
    __properties = ["accessControl", "avatarUrl", "createdAt", "id", "isDisabled", "login", "name", "orgId", "role", "teams", "tokens", "updatedAt"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ServiceAccountProfileDTOBenny:
        """Create an instance of ServiceAccountProfileDTOBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ServiceAccountProfileDTOBenny:
        """Create an instance of ServiceAccountProfileDTOBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ServiceAccountProfileDTOBenny.parse_obj(obj)

        _obj = ServiceAccountProfileDTOBenny.parse_obj({
            "access_control": obj.get("accessControl"),
            "avatar_url": obj.get("avatarUrl"),
            "created_at": obj.get("createdAt"),
            "id": obj.get("id"),
            "is_disabled": obj.get("isDisabled"),
            "login": obj.get("login"),
            "name": obj.get("name"),
            "org_id": obj.get("orgId"),
            "role": obj.get("role"),
            "teams": obj.get("teams"),
            "tokens": obj.get("tokens"),
            "updated_at": obj.get("updatedAt")
        })
        return _obj


