# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class SigV4ConfigBenny(BaseModel):
    """
    SigV4Config is the configuration for signing remote write requests with AWS's SigV4 verification process. Empty values will be retrieved using the AWS default credentials chain.  # noqa: E501
    """
    access_key: Optional[StrictStr] = Field(None, alias="AccessKey")
    profile: Optional[StrictStr] = Field(None, alias="Profile")
    region: Optional[StrictStr] = Field(None, alias="Region")
    role_arn: Optional[StrictStr] = Field(None, alias="RoleARN")
    secret_key: Optional[StrictStr] = Field(None, alias="SecretKey")
    __properties = ["AccessKey", "Profile", "Region", "RoleARN", "SecretKey"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SigV4ConfigBenny:
        """Create an instance of SigV4ConfigBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SigV4ConfigBenny:
        """Create an instance of SigV4ConfigBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SigV4ConfigBenny.parse_obj(obj)

        _obj = SigV4ConfigBenny.parse_obj({
            "access_key": obj.get("AccessKey"),
            "profile": obj.get("Profile"),
            "region": obj.get("Region"),
            "role_arn": obj.get("RoleARN"),
            "secret_key": obj.get("SecretKey")
        })
        return _obj


