# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import List
from pydantic import BaseModel, Field, StrictStr, conlist

class SilenceBenny(BaseModel):
    """
    Silence silence  # noqa: E501
    """
    comment: StrictStr = Field(..., description="comment")
    created_by: StrictStr = Field(..., alias="createdBy", description="created by")
    ends_at: datetime = Field(..., alias="endsAt", description="ends at")
    matchers: conlist(MatcherBennyBenny) = Field(..., description="Matchers matchers")
    starts_at: datetime = Field(..., alias="startsAt", description="starts at")
    __properties = ["comment", "createdBy", "endsAt", "matchers", "startsAt"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SilenceBenny:
        """Create an instance of SilenceBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in matchers (list)
        _items = []
        if self.matchers:
            for _item in self.matchers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['matchers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SilenceBenny:
        """Create an instance of SilenceBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SilenceBenny.parse_obj(obj)

        _obj = SilenceBenny.parse_obj({
            "comment": obj.get("comment"),
            "created_by": obj.get("createdBy"),
            "ends_at": obj.get("endsAt"),
            "matchers": [MatcherBennyBenny.from_dict(_item) for _item in obj.get("matchers")] if obj.get("matchers") is not None else None,
            "starts_at": obj.get("startsAt")
        })
        return _obj


