# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, validator

class SilenceStatusBenny(BaseModel):
    """
    SilenceStatus silence status  # noqa: E501
    """
    state: StrictStr = Field(..., description="state")
    __properties = ["state"]

    @validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('[expired active pending]'):
            raise ValueError("must be one of enum values ('[expired active pending]')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SilenceStatusBenny:
        """Create an instance of SilenceStatusBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SilenceStatusBenny:
        """Create an instance of SilenceStatusBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SilenceStatusBenny.parse_obj(obj)

        _obj = SilenceStatusBenny.parse_obj({
            "state": obj.get("state")
        })
        return _obj


