# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, StrictBool, StrictStr

class SNSConfigBenny(BaseModel):
    """
    SNSConfigBenny
    """
    api_url: Optional[StrictStr] = None
    attributes: Optional[Dict[str, StrictStr]] = None
    http_config: Optional[HTTPClientConfigBennyBenny] = None
    message: Optional[StrictStr] = None
    phone_number: Optional[StrictStr] = None
    send_resolved: Optional[StrictBool] = None
    sigv4: Optional[SigV4ConfigBennyBenny] = None
    subject: Optional[StrictStr] = None
    target_arn: Optional[StrictStr] = None
    topic_arn: Optional[StrictStr] = None
    __properties = ["api_url", "attributes", "http_config", "message", "phone_number", "send_resolved", "sigv4", "subject", "target_arn", "topic_arn"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SNSConfigBenny:
        """Create an instance of SNSConfigBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of http_config
        if self.http_config:
            _dict['http_config'] = self.http_config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sigv4
        if self.sigv4:
            _dict['sigv4'] = self.sigv4.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SNSConfigBenny:
        """Create an instance of SNSConfigBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SNSConfigBenny.parse_obj(obj)

        _obj = SNSConfigBenny.parse_obj({
            "api_url": obj.get("api_url"),
            "attributes": obj.get("attributes"),
            "http_config": HTTPClientConfigBennyBenny.from_dict(obj.get("http_config")) if obj.get("http_config") is not None else None,
            "message": obj.get("message"),
            "phone_number": obj.get("phone_number"),
            "send_resolved": obj.get("send_resolved"),
            "sigv4": SigV4ConfigBennyBenny.from_dict(obj.get("sigv4")) if obj.get("sigv4") is not None else None,
            "subject": obj.get("subject"),
            "target_arn": obj.get("target_arn"),
            "topic_arn": obj.get("topic_arn")
        })
        return _obj


