# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, validator

class TempUserDTOBenny(BaseModel):
    """
    TempUserDTOBenny
    """
    code: Optional[StrictStr] = None
    created_on: Optional[datetime] = Field(None, alias="createdOn")
    email: Optional[StrictStr] = None
    email_sent: Optional[StrictBool] = Field(None, alias="emailSent")
    email_sent_on: Optional[datetime] = Field(None, alias="emailSentOn")
    id: Optional[StrictInt] = None
    invited_by_email: Optional[StrictStr] = Field(None, alias="invitedByEmail")
    invited_by_login: Optional[StrictStr] = Field(None, alias="invitedByLogin")
    invited_by_name: Optional[StrictStr] = Field(None, alias="invitedByName")
    name: Optional[StrictStr] = None
    org_id: Optional[StrictInt] = Field(None, alias="orgId")
    role: Optional[StrictStr] = None
    status: Optional[StrictStr] = None
    url: Optional[StrictStr] = None
    __properties = ["code", "createdOn", "email", "emailSent", "emailSentOn", "id", "invitedByEmail", "invitedByLogin", "invitedByName", "name", "orgId", "role", "status", "url"]

    @validator('role')
    def role_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Viewer', 'Editor', 'Admin'):
            raise ValueError("must be one of enum values ('Viewer', 'Editor', 'Admin')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TempUserDTOBenny:
        """Create an instance of TempUserDTOBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TempUserDTOBenny:
        """Create an instance of TempUserDTOBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TempUserDTOBenny.parse_obj(obj)

        _obj = TempUserDTOBenny.parse_obj({
            "code": obj.get("code"),
            "created_on": obj.get("createdOn"),
            "email": obj.get("email"),
            "email_sent": obj.get("emailSent"),
            "email_sent_on": obj.get("emailSentOn"),
            "id": obj.get("id"),
            "invited_by_email": obj.get("invitedByEmail"),
            "invited_by_login": obj.get("invitedByLogin"),
            "invited_by_name": obj.get("invitedByName"),
            "name": obj.get("name"),
            "org_id": obj.get("orgId"),
            "role": obj.get("role"),
            "status": obj.get("status"),
            "url": obj.get("url")
        })
        return _obj


