# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class ThresholdBenny(BaseModel):
    """
    Threshold a single step on the threshold list  # noqa: E501
    """
    color: Optional[StrictStr] = None
    state: Optional[StrictStr] = None
    value: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="ConfFloat64 is a float64. It Marshals float64 values of NaN of Inf to null.")
    __properties = ["color", "state", "value"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ThresholdBenny:
        """Create an instance of ThresholdBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ThresholdBenny:
        """Create an instance of ThresholdBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ThresholdBenny.parse_obj(obj)

        _obj = ThresholdBenny.parse_obj({
            "color": obj.get("color"),
            "state": obj.get("state"),
            "value": obj.get("value")
        })
        return _obj


