# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, StrictStr, conlist

class TimeIntervalBenny(BaseModel):
    """
    TimeInterval describes intervals of time. ContainsTime will tell you if a golang time is contained within the interval.  # noqa: E501
    """
    days_of_month: Optional[conlist(StrictStr)] = None
    location: Optional[StrictStr] = None
    months: Optional[conlist(StrictStr)] = None
    times: Optional[conlist(TimeRangeBennyBenny)] = None
    weekdays: Optional[conlist(StrictStr)] = None
    years: Optional[conlist(StrictStr)] = None
    __properties = ["days_of_month", "location", "months", "times", "weekdays", "years"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TimeIntervalBenny:
        """Create an instance of TimeIntervalBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in times (list)
        _items = []
        if self.times:
            for _item in self.times:
                if _item:
                    _items.append(_item.to_dict())
            _dict['times'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TimeIntervalBenny:
        """Create an instance of TimeIntervalBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TimeIntervalBenny.parse_obj(obj)

        _obj = TimeIntervalBenny.parse_obj({
            "days_of_month": obj.get("days_of_month"),
            "location": obj.get("location"),
            "months": obj.get("months"),
            "times": [TimeRangeBennyBenny.from_dict(_item) for _item in obj.get("times")] if obj.get("times") is not None else None,
            "weekdays": obj.get("weekdays"),
            "years": obj.get("years")
        })
        return _obj


