# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class UpdateCorrelationCommandBenny(BaseModel):
    """
    UpdateCorrelationCommand is the command for updating a correlation  # noqa: E501
    """
    config: Optional[CorrelationConfigUpdateDTOBennyBenny] = None
    description: Optional[StrictStr] = Field(None, description="Optional description of the correlation")
    label: Optional[StrictStr] = Field(None, description="Optional label identifying the correlation")
    __properties = ["config", "description", "label"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdateCorrelationCommandBenny:
        """Create an instance of UpdateCorrelationCommandBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of config
        if self.config:
            _dict['config'] = self.config.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdateCorrelationCommandBenny:
        """Create an instance of UpdateCorrelationCommandBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdateCorrelationCommandBenny.parse_obj(obj)

        _obj = UpdateCorrelationCommandBenny.parse_obj({
            "config": CorrelationConfigUpdateDTOBennyBenny.from_dict(obj.get("config")) if obj.get("config") is not None else None,
            "description": obj.get("description"),
            "label": obj.get("label")
        })
        return _obj


