# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist, validator

class UpdatePrefsCmdBenny(BaseModel):
    """
    UpdatePrefsCmdBenny
    """
    cookies: Optional[conlist(StrictStr)] = None
    home_dashboard_id: Optional[StrictInt] = Field(0, alias="homeDashboardId", description="The numerical :id of a favorited dashboard")
    home_dashboard_uid: Optional[StrictStr] = Field(None, alias="homeDashboardUID")
    language: Optional[StrictStr] = None
    query_history: Optional[QueryHistoryPreferenceBennyBenny] = Field(None, alias="queryHistory")
    theme: Optional[StrictStr] = None
    timezone: Optional[StrictStr] = None
    week_start: Optional[StrictStr] = Field(None, alias="weekStart")
    __properties = ["cookies", "homeDashboardId", "homeDashboardUID", "language", "queryHistory", "theme", "timezone", "weekStart"]

    @validator('theme')
    def theme_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('light', 'dark', 'system'):
            raise ValueError("must be one of enum values ('light', 'dark', 'system')")
        return value

    @validator('timezone')
    def timezone_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('utc', 'browser'):
            raise ValueError("must be one of enum values ('utc', 'browser')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpdatePrefsCmdBenny:
        """Create an instance of UpdatePrefsCmdBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of query_history
        if self.query_history:
            _dict['queryHistory'] = self.query_history.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpdatePrefsCmdBenny:
        """Create an instance of UpdatePrefsCmdBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpdatePrefsCmdBenny.parse_obj(obj)

        _obj = UpdatePrefsCmdBenny.parse_obj({
            "cookies": obj.get("cookies"),
            "home_dashboard_id": obj.get("homeDashboardId") if obj.get("homeDashboardId") is not None else 0,
            "home_dashboard_uid": obj.get("homeDashboardUID"),
            "language": obj.get("language"),
            "query_history": QueryHistoryPreferenceBennyBenny.from_dict(obj.get("queryHistory")) if obj.get("queryHistory") is not None else None,
            "theme": obj.get("theme"),
            "timezone": obj.get("timezone"),
            "week_start": obj.get("weekStart")
        })
        return _obj


