# coding: utf-8

"""
    Grafana HTTP API.

    The Grafana backend exposes an HTTP API, the same API is used by the frontend to do everything from saving dashboards, creating users and updating data sources.

    The version of the OpenAPI document: 0.0.1
    Contact: hello@grafana.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr

class VersionInfoBenny(BaseModel):
    """
    VersionInfo version info  # noqa: E501
    """
    branch: StrictStr = Field(..., description="branch")
    build_date: StrictStr = Field(..., alias="buildDate", description="build date")
    build_user: StrictStr = Field(..., alias="buildUser", description="build user")
    go_version: StrictStr = Field(..., alias="goVersion", description="go version")
    revision: StrictStr = Field(..., description="revision")
    version: StrictStr = Field(..., description="version")
    __properties = ["branch", "buildDate", "buildUser", "goVersion", "revision", "version"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> VersionInfoBenny:
        """Create an instance of VersionInfoBenny from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> VersionInfoBenny:
        """Create an instance of VersionInfoBenny from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return VersionInfoBenny.parse_obj(obj)

        _obj = VersionInfoBenny.parse_obj({
            "branch": obj.get("branch"),
            "build_date": obj.get("buildDate"),
            "build_user": obj.get("buildUser"),
            "go_version": obj.get("goVersion"),
            "revision": obj.get("revision"),
            "version": obj.get("version")
        })
        return _obj


